# $Id: Makefile,v 5.19 1992/01/24 18:44:19 eggert Exp $
# Copyright (C) 1982, 1988, 1989 Walter Tichy
# Copyright 1990, 1991 by Paul Eggert
#   Distributed under license by the Free Software Foundation, Inc.
#
# This file is part of RCS.
#
# RCS is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# RCS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with RCS; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Report problems and direct all questions to:
#
#    rcs-bugs@cs.purdue.edu
#

# default target
default : all

# See README for more information on the configuration section.
# ----- start of configuration section -----

# Borland makefile definitions

#	$Id: bor.mkh,v 1.6 1992/03/01 23:26:10 eggert Exp $

#CC_286 = -1
CC_286 =

CC_D = -Dbad_creat0=1 -Dbad_chmod_close=1 -Ddeclare_fdopen=1 -Ims\$(s)

CC_MODEL = s

!if $(DEBUG)
CC_O = -v -N
!else
CC_O =
!endif

CFLAGS = -m$(CC_MODEL) -A -G -O -Z -d -w-par -w-pia $(CC_286) $(CC_D) $(CC_O)

INSTALL = -copy

!if $(DEBUG)
LD_V = /v
!else
LD_V =
!endif

LDFLAGS = $(LD_V)/c/n/x

!if !$(BCC)
LIB = \turboc\lib\$(s)
!else
LIB = \borlandc\lib\$(s)
!endif

LOGIN_FLAGS = -A-

OS = dos

RCSDIR = ..\bin

REMOVE = -del

!if $(BCC) < 3
UTIME = utime.obj
!else
UTIME =
!endif


LDLIBS = $(LIB)c$(CC_MODEL)

OTHER_OBJECT = login$(OS).obj spawnvpq.obj $(UTIME)


LINK = tlink $(LIB)c0$(CC_MODEL)$(LD_V) $(LIB)wildargs $(OTHER_OBJECT)

# makefile definitions for MS-DOS and OS/2

#	$Id: ms.mkh,v 1.6 1992/03/01 23:26:13 eggert Exp $

# empty string to avoid makefile misparsing of \ at line end with buggy makes
s =

TESTPREFIX = ms\$(s)

o = .obj
x = .exe

conf.h : ms\conf.h
	copy ms\conf.h .
	echo /* */ >> $@

login$(OS)$(o) : ms\login$(OS).c
	$(CC) $(CFLAGS) $(LOGIN_FLAGS) -c ms\login$(OS).c

dirent$(o) : ms\dirent.c
	$(CC) $(CFLAGS) -c ms\dirent.c

spawnvpq$(o) : ms\spawnvpq.c
	$(CC) $(CFLAGS) -c ms\spawnvpq.c

utime$(o) : ms\utime.c
	$(CC) $(CFLAGS) $(LOGIN_FLAGS) -c ms\utime.c

# On non-Unix hosts you must manually create and edit conf.h from conf.heg.

# ----- end of configuration section -----
# You shouldn't have to change anything past this point.


# Avoid brain damage in some versions of 'make'.
SHELL = /bin/sh

# all commands
RCSCOMMANDS = ci$(x) co$(x) ident$(x) merge$(x) rcs$(x) rcsdiff$(x) rcsmerge$(x) rlog$(x)

all : $(RCSCOMMANDS)

install : all
	$(INSTALL) ci$(x) $(DESTRCSDIR)
	$(INSTALL) co$(x) $(DESTRCSDIR)
	$(INSTALL) ident$(x) $(DESTRCSDIR)
	$(INSTALL) merge$(x) $(DESTRCSDIR)
	$(INSTALL) rcs$(x) $(DESTRCSDIR)
	$(INSTALL) rcsdiff$(x) $(DESTRCSDIR)
	$(INSTALL) rcsmerge$(x) $(DESTRCSDIR)
	$(INSTALL) rlog$(x) $(DESTRCSDIR)

# Install RCS and (if applicable) GNU diff before running these tests.
# To test RCS before installing it, see README.
RCSTEST = PATH=$(RCSDIR):$(DIFFPREFIX).:$$PATH sh $(TESTPREFIX)rcstest
installtest :
	$(RCSTEST)
installdebug :
	$(RCSTEST) -v

clean :
	$(REMOVE) a.* *$(o) conf.h conf.error $(RCSCOMMANDS) rcsclean$(x)


ci = ci$(o) rcslex$(o) rcssyn$(o) rcsgen$(o) rcsedit$(o) rcskeys$(o) rcsmap$(o) \
	rcsrev$(o) rcsutil$(o) rcsfnms$(o) partime$(o) maketime$(o) rcskeep$(o) \
	rcsfcmp$(o) $(OTHER_OBJECT)
ci$(x) : $(ci)
	$(LINK) @ms\$*.rsp,$*,nul,$(LDLIBS)

co = co$(o) rcslex$(o) rcssyn$(o) rcsgen$(o) rcsedit$(o) rcskeys$(o) rcsmap$(o) \
	rcsrev$(o) rcsutil$(o) rcsfnms$(o) partime$(o) maketime$(o) rcskeep$(o) $(OTHER_OBJECT)
co$(x) : $(co)
	$(LINK) @ms\$*.rsp,$*,nul,$(LDLIBS)

ident = ident$(o) rcsmap$(o) $(OTHER_OBJECT)
ident$(x) : $(ident)
	$(LINK) @ms\$*.rsp,$*,nul,$(LDLIBS)

merge = merge$(o) merger$(o) rcsfnms$(o) rcslex$(o) \
	rcsmap$(o) rcsrev$(o) rcssyn$(o) rcsutil$(o) \
	rcskeep$(o) rcskeys$(o) $(OTHER_OBJECT)
merge$(x) : $(merge)
	$(LINK) @ms\$*.rsp,$*,nul,$(LDLIBS)

rlog = rlog$(o) rcslex$(o) rcsmap$(o) rcssyn$(o) rcsrev$(o) rcsutil$(o) partime$(o) \
	maketime$(o) rcsfnms$(o) rcskeep$(o) rcskeys$(o) $(OTHER_OBJECT)
rlog$(x) : $(rlog)
	$(LINK) @ms\$*.rsp,$*,nul,$(LDLIBS)

rcs = rcs$(o) rcslex$(o) rcssyn$(o) rcsrev$(o) rcsutil$(o) rcsgen$(o) rcsedit$(o) rcskeys$(o) \
	rcsmap$(o) rcsfnms$(o) rcskeep$(o) $(OTHER_OBJECT)
rcs$(x) : $(rcs)
	$(LINK) @ms\$*.rsp,$*,nul,$(LDLIBS)

rcsclean = rcsclean$(o) rcsedit$(o) rcsfcmp$(o) rcsfnms$(o) rcsgen$(o) rcskeys$(o) dirent$(o) \
	rcslex$(o) rcsmap$(o) rcsrev$(o) rcssyn$(o) rcsutil$(o) rcskeep$(o) $(OTHER_OBJECT)
rcsclean$(x) : $(rcsclean)
	$(LINK) @ms\$*.rsp,$*,nul,$(LDLIBS)

rcsdiff = rcsdiff$(o) rcsutil$(o) rcsfnms$(o) rcsmap$(o) rcsrev$(o) rcssyn$(o) rcslex$(o) \
	maketime$(o) partime$(o) rcskeep$(o) rcskeys$(o) $(OTHER_OBJECT)
rcsdiff$(x) : $(rcsdiff)
	$(LINK) @ms\$*.rsp,$*,nul,$(LDLIBS)

rcsmerge = rcsmerge$(o) merger$(o) rcsutil$(o) rcsfnms$(o) rcsmap$(o) rcsrev$(o) rcssyn$(o) \
	rcslex$(o) rcskeep$(o) rcskeys$(o) $(OTHER_OBJECT)
rcsmerge$(x) : $(rcsmerge)
	$(LINK) @ms\$*.rsp,$*,nul,$(LDLIBS)

SOURCE=	ci.c co.c ident.c maketime.c merge.c merger.c partime.c rcs.c \
	rcsclean.c rcsdiff.c rcsedit.c rcsfcmp.c rcsfnms.c rcsgen.c \
	rcskeep.c rcskeys.c rcslex.c rcsmap.c rcsmerge.c rcsrev.c rcssyn.c \
	rcsutil.c rlog.c
OBJECT=	ci$(o) co$(o) ident$(o) maketime$(o) merge$(o) merger$(o) partime$(o) rcs$(o) \
	rcsclean$(o) rcsdiff$(o) rcsedit$(o) rcsfcmp$(o) rcsfnms$(o) rcsgen$(o) \
	rcskeep$(o) rcskeys$(o) rcslex$(o) rcsmap$(o) rcsmerge$(o) rcsrev$(o) rcssyn$(o) \
	rcsutil$(o) rlog$(o)

lint : conf.h
	$(LINT) $(CC_D) -DRCS_lint=1 $(SOURCE)

conf_h = conf.h
$(OBJECT) : $(conf_h) rcsbase.h
